import "./menu.css";
import { defineComponent as c, resolveComponent as h, openBlock as i, createElementBlock as r, Fragment as u, createElementVNode as m, mergeProps as s, createVNode as f, withModifiers as v, withCtx as S, renderSlot as l, createTextVNode as y, toDisplayString as g, createBlock as $, Teleport as b, normalizeStyle as P, createCommentVNode as w } from "vue";
import W from "../button/button.js";
import { r as a } from "../../helper-4d4ed314.js";
import { _ as C } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
const k = c({
  props: {
    color: {
      default: "default",
      type: String
    },
    disabled: {
      default: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    noElevation: {
      required: !1,
      type: Boolean
    },
    open: {
      required: !1,
      type: Boolean
    },
    size: {
      default: "base",
      type: String
    },
    tooltip: {
      required: !1,
      type: String
    },
    variant: {
      default: "contained",
      type: String
    }
  },
  name: "sb-menu",
  components: {
    "sb-button": W
  },
  data() {
    return {
      localOpen: !1,
      itemsWrapperStyles: [],
      parentWithScroll: null
    };
  },
  methods: {
    handleClose(e) {
      const o = e.target, t = this.$refs["menu-wrapper"];
      o && t && !t.contains(o) && !o.isSameNode(t) && (this.localOpen = !1);
    },
    handleOpen() {
      this.disabled || (this.localOpen = !0, this.$nextTick(() => {
        this.setPopupPosition();
      }));
    },
    handleParentScroll(e) {
      const o = a(this.$el);
      this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
        this.setPopupPosition();
      }), o && (e ? o.addEventListener("scroll", () => {
        this.setPopupPosition();
      }) : o.removeEventListener("scroll", () => {
        this.setPopupPosition();
      })), this.$nextTick(() => {
        this.parentWithScroll = o;
      });
    },
    setPopupPosition() {
      var o;
      const e = this.$refs["menu-wrapper"];
      if (e) {
        const t = e.getBoundingClientRect(), n = (o = this.$refs["menu-items-wrapper"]) == null ? void 0 : o.getBoundingClientRect();
        if (n)
          return document.body.getBoundingClientRect().height - (t.height + t.y) <= n.height ? this.itemsWrapperStyles = {
            left: `${t.x}px`,
            top: `${t.y - 6 - n.height}px`,
            width: `${t.width}px`
          } : this.itemsWrapperStyles = {
            left: `${t.x}px`,
            top: `${t.y + t.height}px`,
            width: `${t.width}px`
          };
      }
    }
  },
  watch: {
    localOpen(e) {
      this.handleParentScroll(e);
    }
  },
  mounted() {
    this.localOpen = this.open, this.$nextTick(() => this.setPopupPosition()), document.addEventListener(
      "click",
      (e) => this.handleClose(e)
    ), this.parentWithScroll = a(this.$el);
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClose(e)
    ), this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
      this.setPopupPosition();
    });
  }
});
function B(e, o, t, n, p, E) {
  const d = h("sb-button");
  return i(), r(u, null, [
    m("div", s({
      class: "menu-wrapper",
      ref: "menu-wrapper"
    }, { ...e.$attrs }), [
      f(d, s({
        "no-elevation": e.localOpen || e.noElevation,
        type: "button"
      }, {
        color: e.color,
        disabled: e.disabled,
        size: e.size,
        tooltip: e.tooltip,
        variant: e.variant
      }, {
        onClick: v(e.handleOpen, ["stop"])
      }), {
        default: S(() => [
          l(e.$slots, "slot-label", {}, () => [
            y(g(e.label || "..."), 1)
          ], !0)
        ]),
        _: 3
      }, 16, ["no-elevation", "onClick"])
    ], 16),
    (i(), $(b, { to: "body" }, [
      e.localOpen ? (i(), r("div", {
        key: 0,
        class: "menu-items-wrapper",
        ref: "menu-items-wrapper",
        style: P(e.itemsWrapperStyles)
      }, [
        l(e.$slots, "default", {}, void 0, !0)
      ], 4)) : w("", !0)
    ]))
  ], 64);
}
const q = /* @__PURE__ */ C(k, [["render", B], ["__scopeId", "data-v-05568b23"]]);
export {
  q as default
};
